--- plugin/attach.inc.php.orig	2005-08-08 23:54:15.000000000 +0900
+++ plugin/attach.inc.php	2005-11-18 10:43:07.000000000 +0900
@@ -1,7 +1,9 @@
 <?php
 // PukiWiki - Yet another WikiWikiWeb clone
-// $Id: attach.inc.php,v 1.79 2005/08/08 14:54:15 henoheno Exp $
+// $Id: attach.inc.php,v 1.793 2005/11/18 10:30:21 diabah Exp $
 // Copyright (C)
+//   2005      diabah
+//   2004      ARAI
 //   2003-2005 PukiWiki Developers Team
 //   2002-2003 PANDA <panda@arino.jp> http://home.arino.jp/
 //   2002      Y.MASUI <masui@hisec.co.jp> http://masui.net/pukiwiki/
@@ -36,6 +38,15 @@
 define('PLUGIN_ATTACH_FILE_MODE', 0644);
 //define('PLUGIN_ATTACH_FILE_MODE', 0604); // for XREA.COM
 
+// ͥΥƥ (JPEG̻˻)
+define('PLUGIN_THUMB_QUAL', 50); // 0100
+
+// ͥѴˡ (TRUE:Ƴ餫JPEGѴ, FALSE:JPEGϳ餫JPEGˤ¾PNGѴ)
+define('PLUGIN_THUMB_RESAMPLE_ALL', TRUE); // TRUE or FALSE
+
+// ե륪ץξ硢ľƤ (TRUEˤȡоݤե¸פʤʤ)
+define('PLUGIN_OPEN_AVOID_DIRECT', FALSE); // TRUE or FALSE
+
 // File icon image
 define('PLUGIN_ATTACH_FILE_ICON', '<img src="' . IMAGE_DIR .  'file.png"' .
 	' width="20" height="20" alt="file"' .
@@ -44,6 +55,16 @@
 // mime-type򵭽Ҥڡ
 define('PLUGIN_ATTACH_CONFIG_PAGE_MIME', 'plugin/attach/mime-type');
 
+// tar
+define('PLUGIN_TAR_HDR_LEN', 512);		// إå礭
+define('PLUGIN_TAR_BLK_LEN', 512);		// ñ̥֥åĹ
+define('PLUGIN_TAR_HDR_NAME_OFFSET', 0);	// ե̾Υեå
+define('PLUGIN_TAR_HDR_NAME_LEN', 100);	// ե̾κĹ
+define('PLUGIN_TAR_HDR_SIZE_OFFSET', 124);	// ؤΥեå
+define('PLUGIN_TAR_HDR_SIZE_LEN', 12);		// Ĺ
+define('PLUGIN_TAR_HDR_TYPE_OFFSET', 156);	// ե륿פؤΥեå
+define('PLUGIN_TAR_HDR_TYPE_LEN', 1);		// ե륿פĹ
+
 //-------- convert
 function plugin_attach_convert()
 {
@@ -82,6 +103,10 @@
 		$vars['file'] = $vars['openfile'];
 		$vars['pcmd'] = 'open';
 	}
+	if (isset($vars['thumb'])) {
+		$vars['file'] = $vars['thumb'];
+		$vars['pcmd'] = 'thumb';
+	}
 	if (isset($vars['delfile'])) {
 		$vars['file'] = $vars['delfile'];
 		$vars['pcmd'] = 'delete';
@@ -93,7 +118,7 @@
 	$page  = isset($vars['page'])  ? $vars['page']  : '';
 
 	if ($refer != '' && is_pagename($refer)) {
-		if(in_array($pcmd, array('info', 'open', 'list'))) {
+		if(in_array($pcmd, array('info', 'open', 'list', 'thumb'))) {
 			check_readable($refer);
 		} else {
 			check_editable($refer);
@@ -115,6 +140,7 @@
 		case 'info'     : return attach_info();
 		case 'delete'   : return attach_delete();
 		case 'open'     : return attach_open();
+		case 'thumb'    : return attach_thumb();
 		case 'list'     : return attach_list();
 		case 'freeze'   : return attach_freeze(TRUE);
 		case 'unfreeze' : return attach_freeze(FALSE);
@@ -151,7 +177,7 @@
 // $pass = TRUE : åץɵ
 function attach_upload($file, $page, $pass = NULL)
 {
-	global $_attach_messages, $notify, $notify_subject;
+	global $vars, $_attach_messages, $notify, $notify_subject;
 
 	if (PKWK_READONLY) die_message('PKWK_READONLY prohibits editing');
 
@@ -182,13 +208,53 @@
 			'msg'=>$_attach_messages['err_adminpass']);
 	}
 
-	$obj = & new AttachFile($page, $file['name']);
+	if (strcasecmp(substr($file['name'],-4), '.tar') == 0 && $vars['untar_mode'] == 'on') {
+		// Upload줿Tar֤Ÿźդ
+
+		$etars = untar($file['tmp_name']);
+		if ($etars === FALSE) {
+			return array(
+				'result'=>FALSE,
+				'msg'=>$_attach_messages['err_untar']);
+		}
+
+		// Ÿ줿եƥåץɥեȤɲ
+		foreach ($etars as $efile ) {
+			$ret = do_upload($page,
+				mb_convert_encoding($efile['extname'], SOURCE_ENCODING, 'auto'),
+				$efile['tmpname']);
+			if (! $ret['result'] ) {
+				unlink($efile['tmpname']);
+			}
+		}
+
+		return $ret;
+	} else {
+		// ̾ñեźս
+		return do_upload($page, $file['name'], $file['tmp_name']);
+	}
+}
+
+// attach_uploadƤФե륢åץɴؿ
+function do_upload($page, $fname, $tmpname)
+{
+	global $_attach_messages;
+
+	$obj = & new AttachFile($page, $fname);
+	
 	if ($obj->exist)
 		return array('result'=>FALSE,
 			'msg'=>$_attach_messages['err_exists']);
 
-	if (move_uploaded_file($file['tmp_name'], $obj->filename))
-		chmod($obj->filename, PLUGIN_ATTACH_FILE_MODE);
+	if (is_uploaded_file($tmpname)) {
+		if (move_uploaded_file($tmpname, $obj->filename)) {
+			chmod($obj->filename, PLUGIN_ATTACH_FILE_MODE);
+		}
+	} else {
+		if (rename($tmpname, $obj->filename)) {
+			chmod($obj->filename, PLUGIN_ATTACH_FILE_MODE);
+		}
+	}
 
 	if (is_page($page))
 		touch(get_filename($page));
@@ -284,12 +350,32 @@
 		${$var} = isset($vars[$var]) ? $vars[$var] : '';
 	}
 
+	if (PLUGIN_OPEN_AVOID_DIRECT && ! strstr($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST'])) {
+		header('Location: ' . get_script_uri());
+		exit;
+	}
+
 	$obj = & new AttachFile($refer, $file, $age);
 	return $obj->getstatus() ?
 		$obj->open() :
 		array('msg'=>$_attach_messages['err_notfound']);
 }
 
+// ͥ
+function attach_thumb()
+{
+	global $vars, $_attach_messages;
+	
+	foreach (array('refer', 'file', 'age', 'width', 'height') as $var) {
+		${$var} = isset($vars[$var]) ? $vars[$var] : '';
+	}
+
+	$obj = & new AttachFile($refer, $file, $age);
+	return $obj->getstatus() ?
+		$obj->thumb($refer, $file, $width, $height) :
+		array('msg'=>$_attach_messages['err_notfound']);
+}
+
 // 
 function attach_list()
 {
@@ -398,6 +484,7 @@
   <label for="_p_attach_file">{$_attach_messages['msg_file']}:</label> <input type="file" name="attach_file" id="_p_attach_file" />
   $pass
   <input type="submit" value="{$_attach_messages['btn_upload']}" />
+  ({$_attach_messages['msg_untar']}:<input type="checkbox" name="untar_mode">)
  </div>
 </form>
 EOD;
@@ -662,6 +749,48 @@
 		@readfile($this->filename);
 		exit;
 	}
+
+	function thumb($page, $file, $width, $height)
+	{
+		global $_attach_messages;
+
+		// ɸ
+		$size = @getimagesize($this->filename);
+		if (is_array($size)) {
+			$this->width  = $size[0];
+			$this->height = $size[1];
+		} else {
+			return array('result'=>FALSE,
+        			'msg'=>$_attach_messages['err_savethumb']);
+		}
+		$dstw = $dsth = 0;
+		if (is_numeric($width) && is_numeric($height)) {
+			$dstw = $width;
+			$dsth = $height;
+		} else {
+			$ratiow = $width  ? $this->width  / $width  : 0;
+			$ratioh = $height ? $this->height / $height : 0;
+			$ratio = max($ratiow, $ratioh);
+			$dstw = (int)($this->width  / $ratio);
+			$dsth = (int)($this->height / $ratio);
+		}
+
+		if (($dstw == 0) || ($dsth == 0)) {
+			$this->open();
+		}
+
+		$obj  = & new ThumbFile($page, $file, $dstw, $dsth);
+		if ($obj->exist && ($obj->time > $this->time)) {
+			$obj->open();
+		} else {
+			$this->getstatus();
+			if (! $obj->save($this->filename, $this->type, $this->width, $this->height)) {
+				return array('result'=>FALSE,
+        				'msg'=>$_attach_messages['err_savethumb']);
+			}
+			$obj->open();
+		}
+	}
 }
 
 // ե륳ƥ
@@ -790,4 +919,147 @@
 		return "\n" . '<ul>' . "\n" . $ret . '</ul>' . "\n";
 	}
 }
+
+// ͥե
+class ThumbFile
+{
+	var $page, $file;
+	var $time = 0;
+
+	function ThumbFile($page, $file, $dstw, $dsth)
+	{
+		$this->page = $page;
+		$this->file = $file;
+
+		$this->width    = $dstw;
+		$this->height   = $dsth;
+		$this->filename = CACHE_DIR . encode($this->page) . '_' . $dstw . 'x' . $dsth . '_' . $file . '.thumb';
+		$this->exist    = file_exists($this->filename);
+		$this->time     = $this->exist ? filemtime($this->filename) - LOCALZONE : 0;
+	}
+
+	// ե
+	function getstatus()
+	{
+		if (! $this->exist) return FALSE;
+
+		$this->size     = filesize($this->filename);
+		$this->type     = attach_mime_content_type($this->filename);
+
+		return TRUE;
+	}
+
+	// ͥ
+	function save($file, $type, $srcw, $srch)
+	{
+		switch ($type) {
+			case 'image/gif':
+				$src = imagecreatefromgif($file);
+				break;
+			case 'image/jpeg':
+				$src = imagecreatefromjpeg($file);
+				break;
+			case 'image/png':
+				$src = imagecreatefrompng($file);
+				break;
+			default:
+				return FALSE;
+		}
+		if (! $src) {
+			return FALSE;
+		}
+
+		$dst = imagecreatetruecolor($this->width, $this->height);
+		@touch($this->filename); // PHP Bug #35060  ( http://bugs.php.net/bug.php?id=35060 )
+		if (PLUGIN_THUMB_RESAMPLE_ALL || $type == 'image/jpeg') {
+			imagecopyresampled($dst, $src, 0, 0, 0, 0, $this->width, $this->height, $srcw, $srch);
+			imageinterlace($dst, 1);
+			$ret = imagejpeg($dst, $this->filename, PLUGIN_THUMB_QUAL);
+		} else {
+			$alpha = imagecolorallocate($dst, 255, 255, 255);
+			imagefill($dst, 0, 0, $alpha);
+			imagecolortransparent($dst, $alpha);
+			imagecolordeallocate($dst, $alpha);
+			imagesavealpha($dst, TRUE);
+			imagecopyresized($dst, $src, 0, 0, 0, 0, $this->width, $this->height, $srcw, $srch);
+			imageinterlace($dst, 1);
+			$ret = imagepng($dst, $this->filename);
+		}
+		imagedestroy($src);
+		imagedestroy($dst);
+		if (! $ret) {
+			return FALSE;
+		}
+
+		$this->exist = TRUE;
+
+		return TRUE;
+	}
+
+	function open()
+	{
+		$this->getstatus();
+
+		pkwk_common_headers();
+		header('Content-Disposition: inline; filename="' . $this->filename . '"');
+		header('Content-Length: ' . $this->size);
+		header('Content-Type: '. $this->type);
+
+		@readfile($this->filename);
+		exit;
+	}
+
+}
+
+// tar֤Ÿ
+function untar($upfile)
+{
+	$tmpupfile = CACHE_DIR . 'tar_tmpupfile';
+	if (! move_uploaded_file($upfile, $tmpupfile)) {
+		return FALSE;
+	}
+	if (! ($fp = fopen($tmpupfile, 'rb'))) {
+		return FALSE;
+	}
+
+	unset($files);
+	$cnt = 0;
+	while (strlen($buff = fread($fp, PLUGIN_TAR_HDR_LEN)) == PLUGIN_TAR_HDR_LEN) {
+		for ($i = PLUGIN_TAR_HDR_NAME_OFFSET, $name = '';
+			$buff[$i] != "\0" && $i < PLUGIN_TAR_HDR_NAME_OFFSET + PLUGIN_TAR_HDR_NAME_LEN; $i++) {
+			$name .= $buff[$i];
+		}
+		$name = basename(trim($name)); //ǥ쥯ȥꤪ̵
+
+		for ($i = PLUGIN_TAR_HDR_SIZE_OFFSET, $size = '';
+			$i < PLUGIN_TAR_HDR_SIZE_OFFSET + PLUGIN_TAR_HDR_SIZE_LEN; $i++) {
+			$size .= $buff[$i];
+		}
+		list($size) = sscanf('0' . trim($size), '%i'); // 8ʿ
+
+		// ǡ֥å512byteǥѥǥ󥰤Ƥ
+		$pdsz = ((int)(($size + (PLUGIN_TAR_BLK_LEN - 1)) / PLUGIN_TAR_BLK_LEN)) * PLUGIN_TAR_BLK_LEN;
+
+		// ̾Υե뤷ˤʤ
+		$type = $buff[PLUGIN_TAR_HDR_TYPE_OFFSET];
+
+		if ($name && $type == 0) {
+			$buff  = fread($fp, $pdsz);
+			$tname = tempnam(CACHE_DIR, 'tar');
+			if (! ($fpw   = fopen($tname , 'wb'))) {
+				fclose($fp);
+				@unlink($tmpupfile);
+				return FALSE;
+			}
+			fwrite($fpw, $buff, $size);
+			fclose($fpw);
+			$files[$cnt  ]['tmpname'] = $tname;
+			$files[$cnt++]['extname'] = $name;
+		}
+	}
+	fclose($fp);
+	@unlink($tmpupfile);
+
+	return $files;
+}
 ?>
--- plugin/ref.inc.php.orig	2005-05-28 22:31:57.000000000 +0900
+++ plugin/ref.inc.php	2005-07-15 20:38:17.000000000 +0900
@@ -1,6 +1,10 @@
 <?php
 // PukiWiki - Yet another WikiWikiWeb clone
-// $Id: ref.inc.php,v 1.49 2005/05/28 13:31:57 henoheno Exp $
+// $Id: ref.inc.php,v 1.491 2005/07/14 19:25:44 diabah Exp $
+// Copyright (C)
+//   2005      diabah
+//   2004      ARAI
+//   2003-2005 PukiWiki Developers Team
 //
 // Image refernce plugin
 // Include an attached image-file as an inline-image
@@ -118,6 +122,7 @@
 		'nolink' => FALSE, // եؤΥ󥯤ĥʤ
 		'noimg'  => FALSE, // Ÿʤ
 		'zoom'   => FALSE, // Ĳݻ
+		'nothumb'=> FALSE, // ͥȤʤ
 		'_size'  => FALSE, // ꤢ
 		'_w'     => 0,       // 
 		'_h'     => 0,       // ⤵
@@ -264,9 +269,14 @@
 
 			// URI for in-line image output
 			if (! PLUGIN_REF_DIRECT_ACCESS) {
-				// With ref plugin (faster than attach)
-				$url = $script . '?plugin=ref' . '&amp;page=' . rawurlencode($page) .
-					'&amp;src=' . rawurlencode($name); // Show its filename at the last
+				if ($params['nothumb']) {
+					// With ref plugin (faster than attach)
+					$url = $script . '?plugin=ref' . '&amp;page=' . rawurlencode($page) .
+						'&amp;src=' . rawurlencode($name); // Show its filename at the last
+				} else {
+					$url = $script . '?plugin=attach' . '&amp;thumb=' . rawurlencode($name) .
+						'&amp;refer=' . rawurlencode($page);
+				}
 			} else {
 				// Try direct-access, if possible
 				$url = $file;
@@ -332,6 +342,15 @@
 			$height = (int)($height * $params['_%'] / 100);
 		}
 		if ($width && $height) $info = "width=\"$width\" height=\"$height\" ";
+
+		if (! $params['nothumb'] && ! is_url($name)) {
+			if ($width) {
+				$url .= '&amp;width=' . $width;
+			}
+			if ($height) {
+				$url .= '&amp;height=' . $height;
+			}
+		}
 	}
 
 	// 饤Ƚ
--- ja.lng.php.orig	2005-06-16 00:57:11.000000000 +0900
+++ ja.lng.php	2005-11-16 00:19:24.000000000 +0900
@@ -177,9 +177,12 @@
 	'err_delete'   => '$1 եǤޤǤ',
 	'err_password' => 'ѥɤפޤ',
 	'err_adminpass'=> 'ԥѥɤפޤ',
+	'err_savethumb'=> 'ͥǤޤǤ',
+	'err_untar'    => 'tar֤ŸǤޤǤ',
 	'btn_upload'   => 'åץ',
 	'btn_info'     => 'ܺ',
-	'btn_submit'   => '¹'
+	'btn_submit'   => '¹',
+	'msg_untar'    => 'tar֤Ÿź'
 );
 
 ///////////////////////////////////////
--- en.lng.php.orig	2005-06-16 00:57:11.000000000 +0900
+++ en.lng.php	2005-11-18 09:53:12.852280872 +0900
@@ -175,9 +175,12 @@
 	'err_delete'   => 'Cannot delete file in  $1',
 	'err_password' => 'Wrong password.',
 	'err_adminpass'=> 'Wrong administrator password',
+	'err_savethumb'=> 'Unable to save a thumbnail',
+	'err_untar'    => 'Unable to untar',
 	'btn_upload'   => 'Upload',
 	'btn_info'     => 'Information',
-	'btn_submit'   => 'Submit'
+	'btn_submit'   => 'Submit',
+	'msg_untar'    => 'Untar & attach'
 );
 
 ///////////////////////////////////////
